*********************
***   COMOBJ.CH   ***
*********************


#xcommand DECLARE_INTERFACE <cName> ;
          => #undef  IID_<cName>                                     ;;
             #define IID_<cName>  <cName>(.F.)


#xcommand BEGIN_INTERFACE <cName> ;
                          IID <cID> ;
                          <frm: FROM, INHERIT> <iFrom> ;
                          [ <static: STATIC> ] ;
          => _HB_CLASS <cName>                                       ;;
             <static> FUNCTION <cName>( lNew )                       ;;
             STATIC s_oClass, IID := <(cID)>, nMember := 0           ;;
             LOCAL  nScope := 1                                      ;;
             DEFAULT lNew := .T.                                     ;;
             IF s_oClass == NIL                                      ;;
                s_oClass := TClass():New( <(cName)>, ;
                            __CLS_PARAM ( <(iFrom)> ) )              ;;
                nMember := <iFrom>(.F.)[3]                           ;;
             #undef _CLASS_NAME_                                     ;;
             #define _CLASS_NAME_ <cName>                            ;;
             #undef  IID_<cName>                                     ;;
             #define IID_<cName>  <cName>(.F.)


#xcommand BEGIN_INTERFACE <cName> ;
                          IID <cID> ;
                          [ <static: STATIC> ] ;
          => _HB_CLASS <cName>                                       ;;
             <static> FUNCTION <cName>( lNew )                       ;;
             STATIC s_oClass, IID := <(cID)>, nMember := 0           ;;
             LOCAL  nScope := 1                                      ;;
             DEFAULT lNew := .T.                                     ;;
             IF s_oClass == NIL                                      ;;
                s_oClass := TClass():New( <(cName)>, ;
                            __CLS_PARAM ( "IUnknown" ) )             ;;
             #undef _CLASS_NAME_                                     ;;
             #define _CLASS_NAME_ <cName>                            ;;
             #undef  IID_<cName>                                     ;;
             #define IID_<cName>  <cName>(.F.)


#xcommand ICREATE <CLSID> ;
          => ;
          METHOD Create() INLINE ::hObj := CreateOLEObject( <(CLSID)>, IID ), Self


#translate NOREF([@]<x>) => <x>


#xcommand IMETHOD <MethodName>( [<uParam1>] [, <uParamN>] ) => ;
   _HB_MEMBER <MethodName>( [NOREF(<uParam1>)] [, NOREF(<uParamN>)] ) ;;
   s_oClass:AddInline( <(MethodName)>, ;
       COMInterface_GenBlock( { [<(uParam1)>] [, <(uParamN)>] }, ++nMember );
       , 1 )


#xcommand END_INTERFACE ;
          =>    s_oClass:Create() ;;                                 ;;
             ENDIF ;;                                                ;;
             IF lNew                                                 ;;
                RETURN s_oClass:Instance() AS CLASS _CLASS_NAME_     ;;
             ENDIF                                                   ;;
             RETURN { IID, {||_CLASS_NAME_()}, nMember }
