**************************************************************************
*                                                                        *
*  Descripcin: Definicion de algunas interfaces OLEDB                   *
*                                                                        *
*  Autor: Jos F. Gimnez (JFG) - jfgimenez@wanadoo.es                   *
*                                 tecnico.sireinsa@ctv.es                *
*  Fecha: 13-3-2001                                                      *
*                                                                        *
*  Nota: Estas interfaces no estan completas, son solamente una parte.   *
*        Pero son el comienzo...                                         *
*                                                                        *
*  Remark: This interfaces are not complete, but this is the beginning.  *
*                                                                        *
**************************************************************************

#include "FiveWin.ch"
#include "OLEDB.ch"


//-------------------------------------------------------------------------

BEGIN_INTERFACE IDBInitialize IID {0c733a8b-2a1c-11ce-ade5-00aa0044773d}
   METHOD Create( cCLSID ) INLINE ::hObj := CreateOLEObject( cCLSID, IID ), Self
   IMETHOD Initialize()
   IMETHOD Uninitialize()
END_INTERFACE

//-------------------------------------------------------------------------

BEGIN_INTERFACE IDBCreateSession IID {0c733a5d-2a1c-11ce-ade5-00aa0044773d}
   IMETHOD CreateSession( pUnkOuter, riid, ppDBSession )
END_INTERFACE

//-------------------------------------------------------------------------

BEGIN_INTERFACE IADOConnection IID {00000550-0000-0010-8000-00AA006D2EA4}
   METHOD  Create( cCLSID ) INLINE ::hObj := CreateOLEObject( cCLSID, IID ), Self
   IMETHOD GetTypeInfoCount( pctinfo )
   IMETHOD GetTypeInfo( iTInfo, lcid, ppTInfo )
   IMETHOD GetIDsOfNames( riid, rgszNames, cNames, lcid, rgDispId )
   IMETHOD Invoke( dispIdMember, riid, lcid, wFlags, pDispParams, pVarResult, pExcepInfo, puArgErr )
   IMETHOD get_Properties( ppvObject )
   IMETHOD get_ConnectionString( pbstr )
   IMETHOD put_ConnectionString( bstr )
   IMETHOD get_CommandTimeout( plTimeout )
   IMETHOD put_CommandTimeout( lTimeout )
   IMETHOD get_ConnectionTimeout( plTimeout )
   IMETHOD put_ConnectionTimeout( lTimeout )
   IMETHOD get_Version( pbstr )
   IMETHOD Close()
   IMETHOD Execute( CommandText, RecordsAffected, Options, ppiRset )
   IMETHOD BeginTrans( TransactionLevel )
   IMETHOD CommitTrans()
   IMETHOD RollbackTrans()
   IMETHOD Open( ConnectionString, UserID, Password, Options )
   IMETHOD get_Errors( ppvObject )
   IMETHOD get_DefaultDatabase( pbstr )
   IMETHOD put_DefaultDatabase( bstr )
   IMETHOD get_IsolationLevel( Level )
   IMETHOD put_IsolationLevel( Level )
   IMETHOD get_Attributes( plAttr )
   IMETHOD put_Attributes( lAttr )
   IMETHOD get_CursorLocation( plCursorLoc )
   IMETHOD put_CursorLocation( lCursorLoc )
   IMETHOD get_Mode( plMode )
   IMETHOD put_Mode( lMode )
   IMETHOD get_Provider( pbstr )
   IMETHOD put_Provider( Provider )
   IMETHOD get_State( plObjState )
   IMETHOD OpenSchema( Schema, Restrictions, SchemaID, pprset )
   IMETHOD Cancel()
END_INTERFACE

//-------------------------------------------------------------------------

BEGIN_INTERFACE IADORecordset IID {00000556-0000-0010-8000-00AA006D2EA4}
   METHOD  Create( cCLSID ) INLINE ::hObj := CreateOLEObject( cCLSID, IID ), Self
   IMETHOD GetTypeInfoCount( pctinfo )
   IMETHOD GetTypeInfo( iTInfo, lcid, ppTInfo )
   IMETHOD GetIDsOfNames( riid, rgszNames, cNames, lcid, rgDispId )
   IMETHOD Invoke( dispIdMember, riid, lcid, wFlags, pDispParams, pVarResult, pExcepInfo, puArgErr )
   IMETHOD get_Properties( ppvObject )
   IMETHOD get_AbsolutePosition( pl )
   IMETHOD put_AbsolutePosition( Position )
   IMETHOD putref_ActiveConnection( pconn )
   IMETHOD put_ActiveConnection( vConn )
   IMETHOD get_ActiveConnection( pvar )
   IMETHOD get_BOF( pb )
   IMETHOD get_Bookmark( pvBookmark )
   IMETHOD put_Bookmark( vBookmark )
   IMETHOD get_CacheSize( pl )
   IMETHOD put_CacheSize( CacheSize )
   IMETHOD get_CursorType( plCursorType )
   IMETHOD put_CursorType( lCursorType )
   IMETHOD get_EOF( pb )
   IMETHOD get_Fields( ppvObject )
   IMETHOD get_LockType( plLockType )
   IMETHOD put_LockType( lLockType )
   IMETHOD get_MaxRecords( plMaxRecords )
   IMETHOD put_MaxRecords( lMaxRecords )
   IMETHOD get_RecordCount( pl )
   IMETHOD putref_Source( pcmd )
   IMETHOD put_Source( bstrConn )
   IMETHOD get_Source( pvSource )
   IMETHOD AddNew( FieldList, Values )
   IMETHOD CancelUpdate()
   IMETHOD Close()
   IMETHOD Delete( AffectRecords )
   IMETHOD GetRows( Rows, Start, Fields, pvar )
   IMETHOD Move( NumRecords, Start )
   IMETHOD MoveNext()
   IMETHOD MovePrevious()
   IMETHOD MoveFirst()
   IMETHOD MoveLast()
   IMETHOD Open( Source, ActiveConnection, CursorType, LockType, Options )
   IMETHOD Requery( Options )
   IMETHOD _xResync( AffectRecords )
   IMETHOD Update( Fields, Values )
   IMETHOD get_AbsolutePage( pl )
   IMETHOD put_AbsolutePage( Page )
   IMETHOD get_EditMode( pl )
   IMETHOD get_Filter( Criteria )
   IMETHOD put_Filter( Criteria )
   IMETHOD get_PageCount( pl )
   IMETHOD get_PageSize( pl )
   IMETHOD put_PageSize( PageSize )
   IMETHOD get_Sort( Criteria )
   IMETHOD put_Sort( Criteria )
   IMETHOD get_Status( pl )
   IMETHOD get_State( plObjState )
   IMETHOD _xClone( ppvObject )
   IMETHOD UpdateBatch( AffectRecords )
   IMETHOD CancelBatch( AffectRecords )
   IMETHOD get_CursorLocation( plCursorLoc )
   IMETHOD put_CursorLocation( lCursorLoc )
   IMETHOD NextRecordset( RecordsAffected, ppiRs )
   IMETHOD Supports( CursorOptions, pb )
   IMETHOD get_Collect( Index, pvar )
   IMETHOD put_Collect( Index, value )
   IMETHOD get_MarshalOptions( peMarshal )
   IMETHOD put_MarshalOptions( eMarshal )
   IMETHOD Find( Criteria, SkipRecords, SearchDirection, Start )
   IMETHOD Cancel()
   IMETHOD get_DataSource( ppunkDataSource )
   IMETHOD putref_DataSource( punkDataSource )
   IMETHOD _xSave( FileName, PersistFormat )
   IMETHOD get_ActiveCommand( ppCmd )
   IMETHOD put_StayInSync( bStayInSync )
   IMETHOD get_StayInSync( pbStayInSync )
   IMETHOD GetString( StringFormat, NumRows, ColumnDelimeter, RowDelimeter, NullExpr, pRetString )
   IMETHOD get_DataMember( pbstrDataMember )
   IMETHOD put_DataMember( bstrDataMember )
   IMETHOD CompareBookmarks( Bookmark1, Bookmark2, pCompare )
   IMETHOD Clone( LockType, ppvObject )
   IMETHOD Resync( AffectRecords, ResyncValues )
   IMETHOD Seek( KeyValues, SeekOption )
   IMETHOD put_Index( Index )
   IMETHOD get_Index( pbstrIndex )
   IMETHOD Save( Destination, PersistFormat )
END_INTERFACE

//-------------------------------------------------------------------------
